VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Three Control Breaks (Order #, Date, and Month)"
   ClientHeight    =   2730
   ClientLeft      =   5355
   ClientTop       =   3975
   ClientWidth     =   6120
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2730
   ScaleWidth      =   6120
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   795
      Left            =   1613
      TabIndex        =   1
      Top             =   1440
      Width           =   2895
   End
   Begin VB.CommandButton cmdPrint 
      Caption         =   "Print Northwind Sales Report"
      Height          =   795
      Left            =   1613
      TabIndex        =   0
      Top             =   300
      Width           =   2895
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
    
Private mstrYearMonth               As String
Private mstrOrderNbr                As String
Private mstrOrderDate               As String
Private mstrCustID                  As String
Private mstrProdDesc                As String
Private msngUnitPrice               As Single
Private mintQty                     As Integer
Private msngDiscountPct             As Single
    
Private mintLineCtr                 As Integer
Private mintPageCtr                 As Integer
Private mintSalesFileNbr            As Integer
Private mblnEOF                     As Boolean

Private Const mintLINE_START_POS    As Integer = 6

'-----------------------------------------------------------------------------
Private Sub cmdPrint_Click()
'-----------------------------------------------------------------------------
    
    Dim intX                As Integer
    Dim strCustFileName     As String
    Dim strBackSlash        As String

    Dim strPrevMonth        As String
    Dim strPrevDate         As String
    Dim strPrevOrderNbr     As String
    Dim blnNewDate          As Boolean
    Dim blnNewOrder         As Boolean
    Dim strPrintDate        As String
    Dim strPrintOrderNbr    As String
    Dim strPrintCustID      As String

    Dim dblExtPriceDtl      As Double
    Dim dblDiscAmtDtl       As Double
    Dim dblSaleTotDtl       As Double
    
    Dim dblExtPriceOrd      As Double
    Dim dblDiscAmtOrd       As Double
    Dim dblSaleTotOrd       As Double
    
    Dim dblExtPriceDate     As Double
    Dim dblDiscAmtDate      As Double
    Dim dblSaleTotDate      As Double
    
    Dim dblExtPriceMonth    As Double
    Dim dblDiscAmtMonth     As Double
    Dim dblSaleTotMonth     As Double
    
    Dim dblExtPriceGrand    As Double
    Dim dblDiscAmtGrand     As Double
    Dim dblSaleTotGrand     As Double
    
    Const intLINES_PER_PAGE As Integer = 47
    
    On Error GoTo cmdPrint_Click_Error

    ' Have the user make sure his/her printer is ready ...
    If MsgBox("Make sure your printer is on-line and " _
            & "loaded with paper.", vbOKCancel, "Check Printer") = vbCancel _
    Then
        Exit Sub
    End If
    
    ' Set the printer font to Courier, if available (otherwise, we would be
    ' relying on the default font for the Windows printer, which may or
    ' may not be set to an appropriate font) ...
    For intX = 0 To Printer.FontCount - 1
        If Printer.Fonts(intX) Like "Courier*" Then
            Printer.FontName = Printer.Fonts(intX)
            Exit For
        End If
    Next
    
    Printer.FontSize = 10
    Printer.Orientation = vbPRORLandscape
    
    ' initialize page counter ...
    mintPageCtr = 0
                    
    ' prepare file name & number
    strBackSlash = IIf(Right$(App.Path, 1) = "\", "", "\")
    strCustFileName = App.Path & strBackSlash & "NWSALES.txt"
    mintSalesFileNbr = FreeFile

    ' open the input file
    Open strCustFileName For Input As #mintSalesFileNbr
    
    Call PrintHeadings
    
    dblExtPriceGrand = 0
    dblDiscAmtGrand = 0
    dblSaleTotGrand = 0
    
    ' priming read
    Call ReadSalesRecord
    
    ' main outer processing loop
    Do Until mblnEOF
    
        ' set up for month break
    
        strPrevMonth = mstrYearMonth
        
        ' make sure we have enough room to print the month/year heading line
        ' plus at least one detail line
        If mintLineCtr > (intLINES_PER_PAGE - 3) Then
            Call PrintHeadings
        End If
        
        ' print the month heading line
        Printer.FontBold = True
        Printer.Print Tab(mintLINE_START_POS); _
                      UCase$(MonthName(CLng(Right$(mstrYearMonth, 2)))) _
                    & ", " _
                    & Left$(mstrYearMonth, 4)
        Printer.FontBold = False
        Printer.Print
        mintLineCtr = mintLineCtr + 2
        
        dblExtPriceMonth = 0
        dblDiscAmtMonth = 0
        dblSaleTotMonth = 0
        
        ' inner loop 1 for month break
        Do Until (strPrevMonth <> mstrYearMonth) _
              Or (mblnEOF)
              
            ' set up for date break
            
            strPrevDate = mstrOrderDate
            
            dblExtPriceDate = 0
            dblDiscAmtDate = 0
            dblSaleTotDate = 0
              
            blnNewDate = True
              
            ' inner loop 2 for date break
            Do Until (strPrevDate <> mstrOrderDate) _
                  Or (strPrevMonth <> mstrYearMonth) _
                  Or (mblnEOF)
              
                ' set up for order break
                
                strPrevOrderNbr = mstrOrderNbr
                
                dblExtPriceOrd = 0
                dblDiscAmtOrd = 0
                dblSaleTotOrd = 0
                  
                blnNewOrder = True
                              
                ' inner loop 3 for order number break
                Do Until (strPrevOrderNbr <> mstrOrderNbr) _
                      Or (strPrevDate <> mstrOrderDate) _
                      Or (strPrevMonth <> mstrYearMonth) _
                      Or (mblnEOF)
                                              
                    ' if the number of lines printed so far exceeds the
                    ' maximum number of lines allowed on a page, invoke
                    ' the PrintHeadings sub to do a page break
                    If mintLineCtr > intLINES_PER_PAGE Then
                        Call PrintHeadings
                        ' force "group indicated" info to be printed
                        ' if we've had a page break
                        blnNewDate = True
                        blnNewOrder = True
                    End If
                    
                    If blnNewDate Then
                        strPrintDate = mstrOrderDate
                        blnNewDate = False
                    Else
                        strPrintDate = " "
                    End If
                    
                    If blnNewOrder Then
                        strPrintOrderNbr = mstrOrderNbr
                        strPrintCustID = mstrCustID
                        blnNewOrder = False
                    Else
                        strPrintOrderNbr = " "
                        strPrintCustID = " "
                    End If
                                    
                    dblExtPriceDtl = msngUnitPrice * mintQty
                    dblDiscAmtDtl = dblExtPriceDtl * msngDiscountPct
                    dblSaleTotDtl = dblExtPriceDtl - dblDiscAmtDtl
                                     
                    ' print a line of data
                    Printer.Print Tab(11 + mintLINE_START_POS); _
                                  strPrintDate; _
                                  Tab(23 + mintLINE_START_POS); _
                                  strPrintOrderNbr; _
                                  Tab(30 + mintLINE_START_POS); _
                                  strPrintCustID; _
                                  Tab(37 + mintLINE_START_POS); _
                                  mstrProdDesc; _
                                  Tab(70 + mintLINE_START_POS); _
                                  Format$(Format$(msngUnitPrice, "##0.00"), "@@@@@@"); _
                                  Tab(79 + mintLINE_START_POS); _
                                  Format$(mintQty, "@@@"); _
                                  Tab(84 + mintLINE_START_POS); _
                                  Format$(Format$(dblExtPriceDtl, "Currency"), String$(11, "@")); _
                                  Tab(96 + mintLINE_START_POS); _
                                  Format$(Format$(dblDiscAmtDtl, "Currency"), String$(11, "@")); _
                                  Tab(108 + mintLINE_START_POS); _
                                  Format$(Format$(dblSaleTotDtl, "Currency"), String$(11, "@"))
                    ' increment the line count
                    mintLineCtr = mintLineCtr + 1
                    
                    ' "roll" the detail amounts to the order totals
                    dblExtPriceOrd = dblExtPriceOrd + dblExtPriceDtl
                    dblDiscAmtOrd = dblDiscAmtOrd + dblDiscAmtDtl
                    dblSaleTotOrd = dblSaleTotOrd + dblSaleTotDtl
        
                    ' read the next record
                    Call ReadSalesRecord
                    
                Loop
                
                ' end of inner loop 3
                ' we have our break on order number, so print the order totals
                
                ' make sure we have enough room to print the lines for the date totals
                If mintLineCtr > (intLINES_PER_PAGE - 3) Then
                    Call PrintHeadings
                End If
                
                Printer.Print Tab(84 + mintLINE_START_POS); _
                              String$(11, "-"); _
                              Tab(96 + mintLINE_START_POS); _
                              String$(11, "-"); _
                              Tab(108 + mintLINE_START_POS); _
                              String$(11, "-")
                Printer.FontBold = True
                Printer.Print Tab(53 + mintLINE_START_POS); _
                                  "TOTALS FOR ORDER NUMBER " & strPrevOrderNbr & ":"; _
                                  Tab(84 + mintLINE_START_POS); _
                                  Format$(Format$(dblExtPriceOrd, "Currency"), String$(11, "@")); _
                                  Tab(96 + mintLINE_START_POS); _
                                  Format$(Format$(dblDiscAmtOrd, "Currency"), String$(11, "@")); _
                                  Tab(108 + mintLINE_START_POS); _
                                  Format$(Format$(dblSaleTotOrd, "Currency"), String$(11, "@"))
                Printer.FontBold = False
                Printer.Print
                mintLineCtr = mintLineCtr + 3
            
                ' "roll" the order totals to the date totals
                dblExtPriceDate = dblExtPriceDate + dblExtPriceOrd
                dblDiscAmtDate = dblDiscAmtDate + dblDiscAmtOrd
                dblSaleTotDate = dblSaleTotDate + dblSaleTotOrd
            
            Loop
            
            ' end of inner loop 2
            ' we have our break on date, so print the date totals
            
            ' make sure we have enough room to print the lines for the date totals
            If mintLineCtr > (intLINES_PER_PAGE - 2) Then
                Call PrintHeadings
            End If
            
            Printer.FontBold = True
            Printer.Print Tab(61 + mintLINE_START_POS); _
                              Format$("TOTALS FOR " & strPrevDate & ":", String$(22, "@")); _
                              Tab(84 + mintLINE_START_POS); _
                              Format$(Format$(dblExtPriceDate, "Currency"), String$(11, "@")); _
                              Tab(96 + mintLINE_START_POS); _
                              Format$(Format$(dblDiscAmtDate, "Currency"), String$(11, "@")); _
                              Tab(108 + mintLINE_START_POS); _
                              Format$(Format$(dblSaleTotDate, "Currency"), String$(11, "@"))
            Printer.FontBold = False
            Printer.Print
            mintLineCtr = mintLineCtr + 2
            
            ' "roll" the date totals to the month totals
            dblExtPriceMonth = dblExtPriceMonth + dblExtPriceDate
            dblDiscAmtMonth = dblDiscAmtMonth + dblDiscAmtDate
            dblSaleTotMonth = dblSaleTotMonth + dblSaleTotDate
            
        Loop
            
        ' end of inner loop 1
        ' we have our break on month, so print the month totals
        
        ' make sure we have enough room to print the lines for the month totals
        If mintLineCtr > (intLINES_PER_PAGE - 2) Then
            Call PrintHeadings
        End If
        
        Printer.FontBold = True
        Printer.Print Tab(56 + mintLINE_START_POS); _
                          Format$("TOTALS FOR " & _
                          UCase$(MonthName(CLng(Right$(strPrevMonth, 2)))) & ", " & _
                          Left$(strPrevMonth, 4) & ":", String$(27, "@")); _
                          Tab(84 + mintLINE_START_POS); _
                          Format$(Format$(dblExtPriceMonth, "Currency"), String$(11, "@")); _
                          Tab(96 + mintLINE_START_POS); _
                          Format$(Format$(dblDiscAmtMonth, "Currency"), String$(11, "@")); _
                          Tab(108 + mintLINE_START_POS); _
                          Format$(Format$(dblSaleTotMonth, "Currency"), String$(11, "@"))
        Printer.FontBold = False
        Printer.Print
        mintLineCtr = mintLineCtr + 2
        
        ' "roll" the month totals to the grand totals
        dblExtPriceGrand = dblExtPriceGrand + dblExtPriceMonth
        dblDiscAmtGrand = dblDiscAmtGrand + dblDiscAmtMonth
        dblSaleTotGrand = dblSaleTotGrand + dblSaleTotMonth
             
    Loop

    ' end of outer processing loop - time to print the grand totals
    
    ' make sure we have enough room to print the lines for the grand total
    If mintLineCtr > (intLINES_PER_PAGE - 2) Then
        Call PrintHeadings
    End If
    
    Printer.Print
    Printer.FontBold = True
    Printer.Print Tab(70 + mintLINE_START_POS); _
                  "GRAND TOTALS:"; _
                  Tab(84 + mintLINE_START_POS); _
                  Format$(Format$(dblExtPriceGrand, "Currency"), String$(11, "@")); _
                  Tab(96 + mintLINE_START_POS); _
                  Format$(Format$(dblDiscAmtGrand, "Currency"), String$(11, "@")); _
                  Tab(108 + mintLINE_START_POS); _
                  Format$(Format$(dblSaleTotGrand, "Currency"), String$(11, "@"))
    Printer.FontBold = False
    
    ' close the input file
    Close #mintSalesFileNbr

    ' Important! When done, the EndDoc method of the Printer object must be invoked.
    ' The EndDoc method terminates a print operation sent to the Printer object,
    ' releasing the document to the print device or spooler.
    Printer.EndDoc
    
    cmdExit.SetFocus

    Exit Sub

cmdPrint_Click_Error:
    If MsgBox("Error # " & Err.Number & " - " & Err.Description & vbNewLine & _
              "Do you want to continue?", _
              vbYesNo + vbQuestion, _
              "Error") = vbYes Then
        Resume Next
    Else
        End
    End If

End Sub

'-----------------------------------------------------------------------------
Private Sub cmdExit_Click()
'-----------------------------------------------------------------------------
    End
End Sub

'-----------------------------------------------------------------------------
Private Sub ReadSalesRecord()
'-----------------------------------------------------------------------------

    If EOF(mintSalesFileNbr) Then
        mblnEOF = True
    Else
        Input #mintSalesFileNbr, mstrYearMonth, _
                                 mstrOrderDate, _
                                 mstrOrderNbr, _
                                 mstrCustID, _
                                 mstrProdDesc, _
                                 msngUnitPrice, _
                                 mintQty, _
                                 msngDiscountPct
    End If

End Sub

'-----------------------------------------------------------------------------
Private Sub PrintHeadings()
'-----------------------------------------------------------------------------
    
    ' If we are about to print any page other than the first, invoke the NewPage
    ' method to perform a page break. The NewPage method advances to the next
    ' printer page and resets the print position to the upper-left corner of the
    ' new page.
    If mintPageCtr > 0 Then
        Printer.NewPage
    End If
    ' increment the page counter
    mintPageCtr = mintPageCtr + 1

    ' Print 4 blank lines, which provides a for top margin. These four lines do NOT
    ' count toward the limit of 47 lines.
    Printer.Print
    Printer.Print
    Printer.Print
    Printer.Print
    
    ' Print the main headings
    Printer.Print Tab(mintLINE_START_POS); _
                  "Print Date: "; _
                  Format$(Date, "mm/dd/yy"); _
                  Tab(mintLINE_START_POS + 50); _
                  "THEVBPROGRAMMER.COM"; _
                  Tab(mintLINE_START_POS + 110); _
                  "Page:"; _
                  Format$(mintPageCtr, "@@@")
    Printer.Print Tab(mintLINE_START_POS); _
                  "Print Time: "; _
                  Format$(Time, "hh:nn:ss"); _
                  Tab(mintLINE_START_POS + 45); _
                  "NORTHWIND TRADERS SALES REPORT"
    Printer.Print Tab(mintLINE_START_POS + 41); _
                  "WITH BREAKS ON ORDER, DATE, AND MONTH"
    Printer.Print
    ' Print the column headings
    Printer.Print Tab(23 + mintLINE_START_POS); _
                  "ORDER  CUST"; _
                  Tab(72 + mintLINE_START_POS); _
                  "UNIT"; _
                  Tab(87 + mintLINE_START_POS); _
                  "EXTENDED"; _
                  Tab(99 + mintLINE_START_POS); _
                  "DISCOUNT"
    Printer.Print Tab(11 + mintLINE_START_POS); _
                  "ORDER DATE  NUMBER  ID"; _
                  Tab(37 + mintLINE_START_POS); _
                  "PRODUCT DESCRIPTION"; _
                  Tab(71 + mintLINE_START_POS); _
                  "PRICE   QTY"; _
                  Tab(88 + mintLINE_START_POS); _
                  "PRICE"; _
                  Tab(100 + mintLINE_START_POS); _
                  "AMOUNT   SALE TOTAL"
    Printer.Print Tab(11 + mintLINE_START_POS); _
                  "----------  ------  --"; _
                  Tab(37 + mintLINE_START_POS); _
                  "-------------------"; _
                  Tab(71 + mintLINE_START_POS); _
                  "-----   ---"; _
                  Tab(88 + mintLINE_START_POS); _
                  "-----"; _
                  Tab(100 + mintLINE_START_POS); _
                  "------   ----------"
    Printer.Print
    ' reset the line counter to reflect the number of lines that have now
    ' been printed on the new page.
    mintLineCtr = 8

End Sub
